#include<stdio.h>
#include<stdlib.h>
//#include<unistd.h>
#include<sys/ptrace.h>
#include<sys/wait.h>
#include<sys/reg.h>
#include<string.h>


static long pid;
static long asCount;

// sucht syscall id aus dem Userspace des child prozesses
int peekuser(int pid, long off, long *res){
	long val;

	val = ptrace(PTRACE_PEEKUSER ,pid ,off ,0);

	if(val == -1){
		return -1;
	}

	*res = val;
	return 0;
 }

// traced den nächsten assembler step
void trace_asmStep(){
	long res;

	res = ptrace(PTRACE_SINGLESTEP, pid, (char*) 1, 0);

	if(res < 0){
		printf("Failed to execute trace for next assemble step: %ld\n", res);
	} 
}

// Handler methode die mit den Signalen vom Child-Prozess aufgerufen wird (Listener)
void sigchld_handler(int signum){
	long scno;
	int res;

	printf("Assembler Step:\t%lu\n", asCount++);

	trace_asmStep();
}

int main(int argc, char** argv){

	int res;
// standard arg check + cast zu int
	if (argc != 2){
		printf("Usage: ptrace <pid>\n");
		exit(-1);
	}

	pid = strtol(argv[1], NULL, 10);

	if(pid <= 0){
		printf("No valid pid specified\n");
		exit(-1);
	} else {
		printf("Tracing request for pid %ld\n", pid);

	}

// Die Signale vom CHILD Prozess abfangen. (Einen Listener einhängen)
	struct sigaction sigact;
	sigact.sa_handler = sigchld_handler;
	sigaction(SIGCHLD, &sigact, NULL);
// den Prozess <PID> zum Child Prozess machen
	res = ptrace(PTRACE_ATTACH, pid, 0, 0);


	
	if(res < 0){
		printf("Faild to attach: %d\n", res);
		exit(-1);
	} else {
		printf("Attached to %ld\n", pid);
	}

// wait loop
	for(;;){
		wait(&res);
		if(res == 0){
			exit(1);
		}
	}
}
